"Late Start" by Mea & Tom

Section 1 - The Setup

Include Rewrite the Command Line by Ron Newcomb.
Include Exit Lister by Gavin Lambert.
Include Secret Doors by Gavin Lambert.

Release along with an interpreter. 

[To include figures in the final build we also need to run blorbtool.py]
Figure of House is the file "House.jpg".

[We know every direction that a location leads to (unless it's "secret" from the player) - it's our house after all]
A room memory rule:
	rule succeeds.
	
A room can be indoors or outdoors. A room is usually indoors.

A person can be chained or unchained. The player is unchained.

[Allow the player to display the floorplan whenever they like]
Understand "floorplan" as floorplanning. Understand "blueprint" as floorplanning.
Floorplanning is an action applying to nothing.
Carry out floorplanning:
	display the Figure of House;
	

[Allow the player to wait for a longer amount of time - useful for testing]
Waiting more is an action applying to one number.

Understand "wait [a time period]" or "wait for [a time period]" or "wait for a/an [a time period]" or "wait a/an [a time period]" as waiting more.

Carry out waiting more:
	let the target time be the time of day plus the time understood;
	decrease the target time by one minute;
	while the time of day is not the target time:
		follow the turn sequence rules.


[Not really necessary for the story, but included the option to wash the dirty dishes for some flavour]
A thing can be clean or dirty. A thing is usually clean. 
Understand "wash [something]" as washing.
Washing is an action applying to one thing.
Check washing:
	if the noun is not dirty:
		say "[The noun] doesn't need washing. Not urgently, at least." instead;
	if the player is not in the kitchen:
		say "You have nothing to wash [the noun] with here." instead.
Carry out washing:
	if the noun is dirty, now the noun is clean.
Report washing:
	say "You wash [the noun]".



When play begins:
	now the time of day is 7:40 PM; [Sunset on Sept 6 1993]
	[the moon rises at 9:07 PM;] [Moonrise on Sept 6 1993] [This is probably far too long before something "interesting" happens to the player]
	the moon rises at 7:50 PM; [balance this time as necessary to give the player plenty of actions to explore and experiment]
	display the Figure of House;
	change the command line echo mode to echoed by the library;
	if the command line echo mode is always echoed per the interpreter, say "[bold type]Your interpreter does not support some features this game uses.[roman type]".
	[now the right hand status line is "[time of day]";]
	

[This is used to set up the 'Rewrite the Command Line' extension - we'll turn it off until we need it]
When play begins, if the command line echo mode is always echoed per the interpreter, say "(Your interpreter does not support some features this game uses.)"
Before printing a parser error when the command line echo mode is echoed by the story, say line break.

Rule for printing the banner text:  say "[bold type]Late Start[roman type][line break]An Interactive Fiction by Mea & Tom, created with Inform7.

The light is bright. Why is it so bright? You sit up. You keep falling asleep on your couch instead of in your bed. You have to squint at first, against the sunlight streaming in through the window, where the sun is going down. The aches have already begun. You get up..." instead.

The player is in the living room.

A person can be normal, transforming, fully transformed, or untransformed. The player is normal.

[A thing can be tasty or untasty. A thing is usually untasty].

Instead of examining the player:
	if the player is normal, say "Your muscles ache, and you have the beginnings of a headache.";
	if the player is transforming, say "Patchy fur is sprouting all over you! And do your teeth feel longer?!";
	if the player is fully transformed, say "Awoo!".
	

Section 2 - The Locations

[LIVING ROOM]
The living room is a room.
"The living room is a bit of a mess; there's hair all over the sofa, and one corner of the rug is rucked up.".
The coffee table is here. The coffee table is scenery.
 The empty pizza box is on the coffee table. The description of the pizza box is "The pizza boy has scribbled his number on the inside of the box. Huh. If only you had a phone.".
A chair is a kind of supporter. A chair is always enterable.
In the living room is the sofa. The sofa is a chair. The sofa is scenery.
A mug is a kind of thing. A mug is usually dirty. 3 mugs are on the coffee table.
A wooden chair is a thing. A wooden chair is a chair. There are 2 wooden chairs in the living room. The wooden chairs are scenery.
The door key is here.  "Beside the door, hanging on a hook, is your key to the front door." The door key unlocks the front door.

[TV]
Understand "Tune [thing]" as tuning. Understand "Change channel" as tuning. Understand "Change [thing] channel" as tuning.
Tuning is an action applying to one thing.
Check tuning:
	if the noun is not the TV, say "[the noun] does not have any channels to change!" instead;
Carry out tuning:
	increase the channel of the TV by 1;
	if the channel of the TV is 5:
		now the channel of the TV is 1;
Report tuning:
	if the TV is switched on:
		say "A [channel message] flickers onto the screen.";
	otherwise:
		say "Nothing appears to happen, but that isn't surprising: the TV isn't on."

Understand "watch [thing]" as watching.
Watching is an action applying to one thing.
Check watching:
	if the noun is the TV and the TV is switched off:
		say "That doesn't sound very interesting - it isn't even turned on." instead;		
Carry out watching:
	if the noun is the TV:
		try silently waiting more five;
	otherwise:
		try examining the noun instead;
Report watching:
	if the noun is the TV:
		say "You spend five minutes watching a [channel message]";


The TV is a device in the living room. "Against the wall is a TV with a smudged screen and a VCR beneath it.[if switched on] A [channel message] is playing.[end if] The time on the VCR reads [time of day]." The TV is switched off. The TV is fixed in place.
A TV has a number called the channel. The channel of the TV is 1.
After switching on the TV, say "A [channel message] comes onto the screen.".
To say channel message:
	if the channel of the TV is 1:
		say "cooking show";
	otherwise if the channel of the TV is 2:
		say "gardening show";
	otherwise if the channel of the TV is 3:
		say "news broadcast";
	otherwise:
		say "reality TV show".

[VCR]
The VCR is a device in the living room. The VCR is switched off. The VCR is scenery.
Instead of switching on the VCR, say "There's no cassette in it yet."


[CANDLE]
On the table is the candle. The description of the candle is "A [if the candle is lit]merrily burning [otherwise if the candle has been lit]partially burnt [end if]candle[if the candle has not been lit] still in pristine condition with untouched wick[end if]."
On the table is the box of matches. [The box of matches is opaque. The box of matches contains 3 matches.] Understand "matchbox" as the box of matches.
The block burning rule does nothing when the noun is the candle.
Instead of burning the lit candle:
	say "The candle is already lit."
Check burning:
	if the noun is not the candle, say "Setting fire to [the noun] doesn't seem like the best idea." instead;
	if the player is not carrying the box of matches, say "You have nothing to light the candle with." instead;
Carry out burning the candle:
	now the candle is lit.
Report burning:
	if the candle had been lit, say "You relight the candle.";
	otherwise say "You light the candle with a match from the box.".
Understand "blow out [something]" as blowing out. Understand "extinguish [something]" as blowing out. Understand "blow [something] out" as blowing out. Blowing out is an action applying to one thing.
Carry out blowing out the candle:
	now the candle is unlit.
Report blowing out:
	if the noun is the candle and the candle was lit, say "You blow out [the noun].";
	otherwise say "You blow on [the noun], to little effect."



[TRAPDOOR]
Understand "lift [something]" as looking under.
The rug is here. The description of the rug is "A worn and slightly threadbare rug. It looks as though it has been frequently moved."
The trapdoor is a secret door. The trapdoor is down from the living room. The cellar is down from the trapdoor. The trapdoor is locked. The brass key unlocks the trapdoor. The description of the trapdoor is "A heavy-looking trapdoor[if locked], secured with an equally heavy looking brass padlock[otherwise]. The padlock hangs invitingly open[end if]."
A door obviousness rule for the trapdoor:
	if the cellar is not visited, rule fails.
Instead of pushing the rug, try looking under the rug.
Instead of looking under the rug for the first time:
	say "Under the rug is a heavy-looking trapdoor, secured with an equally heavy looking padlock!";
	now the trapdoor is revealed;
	now the trapdoor is not scenery.

Before locking the trapdoor with the brass key:
	if the player is in the cellar:
		say "You can't reach the lock from this side of the door. In retrospect, this was poor design." instead.

[CELLAR]
The cellar is a dark room. "A storm shelter, dug into the ground beneath your cabin. There is a bench built in the wall opposite you, and a ring protruding from the wall above it."
The bench is here. The bench is a chair. The bench is scenery.
The metal ring is here. The metal ring is scenery. The description of the metal ring is "A wrought iron ring, securely fastened to the wall above the bench."
A shelf is here. The shelf is a supporter. The shelf is scenery. The description of the shelf is "A set of freestanding metal shelves, old with specks of rust, holding up your last few jars."
Understand "shelves" as the shelf.
On the shelf is a pickle jar. The description of the pickle jar is "A jar of delicious pickles." A pickle is an edible thing. The pickle jar contains 16 pickles.
On the shelf is a corn jar. The description of the corn jar is "A jar of delicious corn." A corn is an edible thing. The corn jar contains 3 corns.
On the shelf is a metal box. The description of the metal box is "A heavy-looking metal box.". The metal box is a container that is opaque, closed, and openable. In the box is a metal chain. Understand "box" as the metal box.
Instead of taking the metal box:
	if the chain is in the metal box:
		say "The box is too heavy to lift!";
	otherwise:
		say "There's no need to take that now.".


Understand the command "chain" as "tie".

The block tying rule does nothing when the player is carrying the chain.

Check tying:
	if the noun is the player and the second noun is the metal ring and the player is carrying the chain:
		do nothing;
	otherwise:
		say "You're not sure how to accomplish that." instead.
		
Carry out tying:
	if the noun is the player and the second noun is the metal ring and the player is carrying the chain:
		now the player is chained.
		
Report tying:
	if the noun is the player and the second noun is the metal ring and the player is carrying the chain:
		say "You tie yourself to the metal ring as best you're able. You just hope it will hold.".



Instead of doing something other than looking or examining or waiting or waiting more while the player is chained:
	say "You can't do that now that you're chained to the wall - there's nothing left to do but wait, and hope.".
	


[KITCHEN]
The kitchen is a room. The kitchen is north of the living room.
"Your kitchen is small, but not too small. It has been a while since you did the dishes. Through the window, you can see the sun setting. On the opposite wall, the clock reads [time of day]."
Instead of smelling the kitchen, say "Stale coffee and stale bread."
In the kitchen is a kettle. The description of the kettle is "A cheap, plastic kettle, half full of water". Instead of taking the kettle, say "That doesn't seem useful."
In the kitchen is a toaster. The description of the toaster is "A slightly greasy toaster." Instead of taking the toaster, say "That doesn't seem useful."
In the kitchen is a clock. The clock is scenery. The description of clock is "The clock reads [time of day]."
In the kitchen is a pile of dishes. The pile of dishes is dirty. The printed name of the dishes is "pile of [if dirty]dirty[otherwise]clean[end if] dishes". The description of the dishes is "[if dirty]A pile of stained plates, with the crumbs of former meals stuck to them.[otherwise]A pile of freshly washed plates, drying on the counter." Instead of taking the dishes, say "[if dirty]Gross. That doesn't seem useful.[otherwise]Less gross, but that still doesn't seem useful."
In the kitchen is the fridge. The fridge is a container that is closed, opaque, and openable. In the fridge is a package of raw meat, a bottle of juice, and a can of soda.
In the kitchen is the western window. The western window is scenery. The description of the western window is "[if time of day is before 8 PM]Your garden, such as it is; a pair of logs for benches and a small firepit.[otherwise]The sun has fully set; a dim glow at the horizon says that the moon will be up soon."
In the kitchen is the northern window. The northern window is scenery. The description of the northern window is "[if time of day is before 8 PM]Your garden, such as it is; a pair of logs for benches and a small firepit.[otherwise]The sun has fully set; a dim glow at the horizon says that the moon will be up soon."


[BATHROOM]
The bathroom is a room. The bathroom is north of the bedroom. "The bathroom is cramped, grimy, and smells of wet dog. You don't own a dog."
In the bathroom is a mirror.
In the bathroom is a cabinet. The cabinet is a container that is closed, opaque, and openable. In the cabinet is a bottle of pain medication. A pill is a kind of edible thing. The bottle of pain medication contains 6 pills.
Before examining the mirror:
	if the cabinet is open, say "You'll need to close the cabinet first." instead.
Instead of examining the mirror:
	if the player is normal, say "You look the same as always. Maybe a little tired.";
	if the player is transforming, say "Patchy fur is sprouting all over you! And are your teeth getting longer?!";
	if the player is fully transformed, say "A giant wolf-like creature stares back at you.".


[BEDROOM]
The bedroom is a room. The bedroom is west of the living room. "The bedroom is a mess. Your bed is unmade. One of the wooden legs looks chewed. Your clothes are spilling from your dresser, strewn across the floor. Dim light filters through the windows in the western and southern walls. The alarm clock on your bedside table reads [time of day]."
In the bedroom is a calendar. The description of the calendar is "Today is circled. It's September 6th, the moon tonight is full, your motto for the week is 'The best way to predict the future is to create it', and apparently it's Debbie's birthday. Happy birthday, Debbie."
The dresser is here. The dresser is scenery. The brass key is on the dresser. The description of the brass key is "A surprisingly heavy key."
In the bedroom is the bedroom window. The bedroom window is scenery. The description of the bedroom window is "[if time of day is before 8 PM]To the south you can just about see the gravel road leading to your cabin.[otherwise]The sun has fully set; a dim glow at the horizon says that the moon will be up soon."




[PORCH]
The front door is a door. The front door is a scenery. The front door is east of the living room. The front door is lockable, and unlocked.
The porch is a room. The porch is outdoors. The porch is east of the front door. "The front steps of your cabin. You get the feeling you shouldn't stray too far from the cabin in the dark."


[REAR GARDEN]



[WOODS?]
[If the player stumbles blindly into the woods, they get lost as it gets dark?]


Section 3 - The Transformation

At the time when the moon rises:
	say "[bold type]The moon peeks through the clouds and you feel something stir inside of you...[roman type]";
        now the player is transforming.


After reading a command while the player is transforming:
	say "[line break][bold type]";
	if the player has been transforming for less than three turns:
		say "[one of]You start to cough.[or]You growl involuntarily.[or]You twitch.[then at random]";
	otherwise if the player has been transforming for less than six turns:
		say "[one of]You convulse violently![or]Fur starts to sprout from your arms![or]Your back spasms![then at random]";
	otherwise if the player has been transforming for less than eight turns:
		say "You cannot control the wolf for much longer....";
	otherwise [if the player has been transforming for at least ten turns]:
		now the player is fully transformed;
		say "You have lost control of the beast inside you!";
		now everything carried by the player is in the location;
		change the command line echo mode to echoed by the story;
	say "[roman type]".

Section 4 - The Werewolf

Definition: a direction (called thataway) is viable if the room thataway from the location is a room and thataway is not down. [Added an extra caveat to prevent the Wolf going to the cellar - especially if the player hasn't discovered it!]

Transformed turns is a number that varies. Transformed turns is 0.

[TODO: rewrite this as more of a statemachine - with specific goals (e.g., escape, eat, etc.) in mind]
After reading a command while the player is fully transformed:
	Increase transformed turns by 1;
	if transformed turns is 8:
		now the player is untransformed;
	otherwise if the player has been fully transformed for at least one turn:
		[Check for conditions that end the game]
		if the player is in the porch:
			now the player is untransformed;
		otherwise if the candle is in the location and the candle is lit:
			now the player is untransformed;
		[Otherwise, if the front door is unlocked, try and move towards it]
		otherwise if the front door is unlocked: 
			let D be south;
			if the player is in the bathroom or the player is in the kitchen:
				now D is south;
			otherwise if the player is in the bedroom or the player is in the living room:
				now D is east;
			otherwise :
				now D is up;
			say "[input type]Go [D][roman type]";
			try going D instead;
		[Fallback to behaving randomly if nothing else to do]
		otherwise:
			let Things be the list of things in the location;
			sort Things in random order;
			let T be entry 1 of Things;
			let N be a random number between 1 and 39;
			if N is less than 10:
				let Directions be the list of viable directions;
				sort Directions in random order;
				let D be entry 1 of Directions;
				say "[input type]Go [D][roman type]";
				try going D instead;
			otherwise if N is less than 20:
				say "[input type]Sniff [T][roman type]";
				try smelling T instead;
			otherwise if N is less than 30:
				if T is edible:
					say "[input type]Eat [T][roman type]";
					try eating T instead;
				otherwise:
					say "[input type]Lick [T][roman type]";
					say "[line break]You tentatively lick [the T]. It does not taste appetising." instead;
			otherwise if N is less than 40:
				say "[input type]Scratch self[roman type]";
				say "[line break]You sprawl on the ground and scratch your flank with your hind leg.";
				say "That's the spot!" instead;
			[otherwise:
				say "[input type]Awooooooooooooo![roman type]".]


Section 5 - The Epilogue

[After going to a room that is outdoors while the player is fully transformed:
	end the story saying "You lost control. The Wolf made it out of the house. When you wake up the next morning, there's blood under your fingernails. Goodness only knows what you've done...".]
	

[Every turn while the player is fully transformed:
	if the candle is in the location and the candle is lit:
		end the story saying "With a sweep of your powerful table, you knock the lighted candle to the floor. In a matter of moments, the wooden floor is ablaze, followed by the furniture, and eventually the whole room. Much, much later, you wake up, unharmed, curled up in the ashes of your home.".]


[These checks are all getting duplicated above; for some reason checking here with "Every turn while the player is gully transformed" isn't workign as expected]
Every turn while the player is untransformed:
	if the player is in the porch:
		end the story saying "You lost control. The Wolf made it out of the house. When you wake up the next morning, there's blood under your fingernails. Goodness only knows what you've done...";
	otherwise if the player is chained:
		end the story saying "You were smart to keep yourself locked away - your secret is safe and you didn't hurt anyone. Maybe next month won't be too bad either.";
	otherwise if the candle is in the location and the candle is lit:
		end the story saying "With a sweep of your powerful tail, you knock the lighted candle to the floor. In a matter of moments, the wooden floor is ablaze, followed by the furniture, and eventually the whole room. Much, much later, you wake up, unharmed, curled up in the ashes of your home.";
	otherwise:
		end the story saying "After running wild throughout the night, you gradually come to your senses. It seems like you managed not to hurt anyone, or even destroy your cabin too badly. Maybe next month won't be too bad either."
		

Section 6 - Testing

Test all with "take key / lock front door / wait 19 minutes / l / l / l / l / l / l / l / l / l / l / l / l / l / l / l / l / l / l / l / l / l / l / l / l / l / l / l / l / l / l / l / l / l / l / l"

[Test all with "move rug / w / get key / e / take matchbox / light candle / take candle / unlock trapdoor with brass key / d / open metal box / take chain / tie self to ring / wait 5 minutes".]